#include <stdio.h>
#include <stdlib.h>

//     ============>  
//    -|-    |     |
//   --|--   |     |
//  ---|---  |     |
//     1     2     3 

int nopr = 0;

void put( int from, int to ) {
   printf( "%d => %d,   ", from, to );
   if( 0 == ( ++nopr % 5 ) )
      printf( "\n" ); 
}

int temp( int from, int to ) {  // промежуточная позиция
   int i = 1;
   for( ; i <= 3; i++ )
      if( i != from && i != to )
         return i;
   return 0;                    // ошибка
}

void move( int from, int to, int n ) {
   if( 1 == n ) put( from, to );
   else {
      move( from, temp( from, to ), n - 1 );
      put( from, to );
      move( temp( from, to ), to, n - 1 );
   }
}

int main( int argc, char **argv, char **envp ) {
   int n = 5;                 // число переносимых фишек
   if( argc > 1 && atoi( argv[ 1 ] ) != 0 )
      n = atoi( argv[ 1 ] );   
   printf( "размер пирамиды: n=%d\n", n ); 
   move( 1, 3, n );           // вот и всё решение!
   if( 0 != ( nopr % 5 ) )
      printf( "\n" ); 
   printf( "общее число перемещений %d\n", nopr ); 
   return 0;
}
