#include <stdio.h>
#include <stdlib.h>

unsigned long long fact1( int n ) {
   unsigned long long f = 1;
   int i;
   for( i = 1; i <= n; i++ ) f *= i;
   return f;
}

unsigned long long fact2( int n ) {
   unsigned long long f = 1;
   while( n > 1 ) f *= n--;
   return f;
}

unsigned long long fact3( int n ) {
   return 0 == n || 1 == n ? 1 : n * fact3( n - 1 );
}

int main( int argc, char **argv, char **envp ) {
   int n, m, i;
   unsigned long long ( *funcs[] )( int ) = { 
      fact1, fact2, fact3
   };
   while( 1 ) {
      printf( "число: " );
      fflush( stdout );
      m = scanf( "%d", &n );
      if( m <= 0 ) {
         printf( "\n" );      
         break;
      }
      printf( "%d! => ", n );
      for( i = 0; i < sizeof( funcs ) / sizeof( funcs[ 0 ] ); i++ ) 
         printf( "%llu ,  ", funcs[ i ]( n ) ); 
      printf( "\n" );      
   }
   return 0;
}

